- name: Creates directory
  file:
    path: /etc/systemd/system/docker.service.d/
    state: directory

- name: Create an override for docker systemd service
  template:
    src: override.j2
    dest: /etc/systemd/system/docker.service.d/override.conf
    owner: root
    group: root
    mode: 0644

- name: Enable systemd socket for unix socket access
  command: systemctl enable docker.socket

- name: Backup the CA
  fetch:
    src: /home/ec2-user/.docker/ca.pem
    dest: output/certs-{{ ec2_public_ip }}/
    flat: yes

- name: Backup the cert
  fetch:
    src: /home/ec2-user/.docker/cert.pem
    dest: output/certs-{{ ec2_public_ip }}/
    flat: yes

- name: Backup the key
  fetch:
    src: /home/ec2-user/.docker/key.pem
    dest: output/certs-{{ ec2_public_ip }}/
    flat: yes

- name: copy the content of the CA pem
  slurp:
    src: /home/ec2-user/.docker/ca.pem
  register: ca_pem

- name: copy the content of the cert pem
  slurp:
    src: /home/ec2-user/.docker/cert.pem
  register: cert_pem

- name: copy the content of the key pem
  slurp:
    src: /home/ec2-user/.docker/key.pem
  register: key_pem

- name: Copy the CA pem to GITLAB CI environment variable (first time)
  uri:
    url: "{{ gitlab_url }}/variables"
    method: POST
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
    body_format: json
    body:
      key: "docker{{ target_host }}_tlsauth_ca"
      value: "{{ ca_pem['content'] | b64decode }}"
      environment_scope: "{{ gigadb_environment }}"
    status_code:
      - 201
      - 400
  register: ca_post_outcome

- name: Copy the CA pem to GITLAB CI environment variable (subsequently)
  uri:
    url: "{{ gitlab_url }}/variables/docker{{ target_host }}_tlsauth_ca?filter%5benvironment_scope%5d={{ gigadb_environment }}"
    method: PUT
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
    body_format: json
    body:
      value: "{{ ca_pem['content'] | b64decode }}"
    status_code: 200
  register: ca_put_outcome
  when: ca_post_outcome.status == 400

- name: Copy the cert pem to GITLAB CI environment variable (first time)
  uri:
    url: "{{ gitlab_url }}/variables"
    method: POST
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
      # Content-Type: application/x-www-form-urlencoded
    body_format: json
    body:
      key: "docker{{ target_host }}_tlsauth_cert"
      value: "{{ cert_pem['content'] | b64decode }}"
      environment_scope: "{{ gigadb_environment }}"
    status_code:
      - 201
      - 400
  register: cert_post_outcome

- name: Copy the cert pem to GITLAB CI environment variable (subsequently)
  uri:
    url: "{{ gitlab_url }}/variables/docker{{ target_host }}_tlsauth_cert?filter%5benvironment_scope%5d={{ gigadb_environment }}"
    method: PUT
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
    body_format: json
    body:
      value: "{{ cert_pem['content'] | b64decode }}"
    status_code: 200
  register: cert_put_outcome
  when: cert_post_outcome.status == 400

- name: Copy the key pem to GITLAB CI environment variable
  uri:
    url: "{{ gitlab_url }}/variables"
    method: POST
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
      # Content-Type: application/x-www-form-urlencoded
    body_format: json
    body:
      key: "docker{{ target_host }}_tlsauth_key"
      value: "{{ key_pem['content'] | b64decode }}"
      environment_scope: "{{ gigadb_environment }}"
    status_code:
      - 201
      - 400
  register: key_post_outcome

- name: Copy the key pem to GITLAB CI environment variable (subsequently)
  uri:
    url: "{{ gitlab_url }}/variables/docker{{ target_host }}_tlsauth_key?filter%5benvironment_scope%5d={{ gigadb_environment }}"
    method: PUT
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
    body_format: json
    body:
      value: "{{ key_pem['content'] | b64decode }}"
    status_code: 200
  register: key_put_outcome
  when: key_post_outcome.status == 400

- name: copy the private ip address to GITLAB CI environment variable (first time)
  uri:
    url: "{{ gitlab_url }}/variables"
    method: POST
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
      # Content-Type: application/x-www-form-urlencoded
    body_format: json
    body:
      key: "remote{{ target_host }}_private_ip"
      value: "{{ (target_host == '_bastion') | ternary(ec2_bastion_private_ip,ec2_private_ip) }}"
      environment_scope: "{{ gigadb_environment }}"
    status_code:
      - 201
      - 400
  register: private_ip_post_outcome

- name: copy the private ip address to GITLAB CI environment variable (subsequently)
  uri:
    url: "{{ gitlab_url }}/variables/remote{{ target_host }}_private_ip?filter%5benvironment_scope%5d={{ gigadb_environment }}"
    method: PUT
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
    body_format: json
    body:
      value: "{{ (target_host == '_bastion') | ternary(ec2_bastion_private_ip,ec2_private_ip) }}"
    status_code: 200
  register: private_ip_put_outcome
  when: private_ip_post_outcome.status == 400

- name: copy the public ip address to GITLAB CI environment variable (first time)
  uri:
    url: "{{ gitlab_url }}/variables"
    method: POST
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
      # Content-Type: application/x-www-form-urlencoded
    body_format: json
    body:
      key: "remote{{ target_host }}_public_ip"
      value: "{{ (target_host == '_bastion') | ternary(ec2_bastion_public_ip,ec2_public_ip) }}"
      environment_scope: "{{ gigadb_environment }}"
    status_code:
      - 201
      - 400
  register: public_ip_post_outcome

- name: copy the public ip address to GITLAB CI environment variable (subsequently)
  uri:
    url: "{{ gitlab_url }}/variables/remote{{ target_host }}_public_ip?filter%5benvironment_scope%5d={{ gigadb_environment }}"
    method: PUT
    headers:
      PRIVATE-TOKEN: "{{ gitlab_private_token }}"
    body_format: json
    body:
      value: "{{ (target_host == '_bastion') | ternary(ec2_bastion_public_ip,ec2_public_ip) }}"
    status_code: 200
  register: public_ip_put_outcome
  when: public_ip_post_outcome.status == 400
